
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

#ifndef __IDLPARSER_H__
#define __IDLPARSER_H__

#include <stdio.h>
#include <fstream.h>
#ifndef __GNUG__
#include "stl.h"
#endif

class IDLParser;

extern char *idl_lexFile;            // Defined in scanner.l
extern IDLParser *theIDLParser;  // Defined in idlparser.cc
int yyidlparse();                // Defined through yacc.y

class IDLParser 
{
private:
    char   *errorFile;
    char   *errorMsg;
    int     errorLine;
    ostream &ostr;
public:
    IDLParser(istream &istr, char *filename = NULL, ostream &o = cout);
    ~IDLParser();
    void Parse();
    void SetError( char *file, char *err, int line );
    bool ErrorOccured();
    char *GetErrorFile();
    char *GetErrorMsg();
    int   GetErrorLine();
    ostream& GetOutputStream();
	
};


#endif
