/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


#ifndef __IDLTRANSFORM_H__
#define __IDLTRANSFORM_H__


#include <strstream.h>
#include <Trader.h>

#include "idlconverter.h"
#include "idlparsenode.h"
#include "cgtransform.h"



class CORBA2Template
{
private:
    ostream &ostr;
public:
    CORBA2Template( ostream &o, IDLParseNode *node );
    ConceptualGraph* ConvertStream2ConceptualGraph( istream &i ); 
    ~CORBA2Template();
};



class DCE2Template
{
public:
    DCE2Template( ostream &o, IDLParseNode *node );
    ~DCE2Template();
};


#endif

