
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


import java.awt.*;
import java.applet.Applet;
import TransportLayer;
import DemoIDL;


public class IDLTool extends Applet {
    Button			b1_l;
    Button			b2_l;
    Button			b3_l;
    TextArea			t1_l;
    Button			b_clear1_l;
    Button			b_to_cg_l;
    Button			b_from_cg_l;
    Choice			c_l;
    TextArea			t2_l;
    Button			b_clear2_l;
    
    Button			b1_r;
    Button			b2_r;
    Button			b3_r;
    TextArea			t1_r;
    Button			b_clear1_r;
    Button			b_to_cg_r;
    Button			b_from_cg_r;
    Choice			c_r;
    TextArea			t2_r;
    Button			b_clear2_r;
    
    Label			l_1, l_2, l_3;
    Button			b_comp;
    
    Panel			p_l, p_r, p_b;
    
    GridBagLayout gridbag = new GridBagLayout();
    IDLToolSet toolset = new IDLToolSet();

public void init()
    {
        Font fixed14 = new Font ("fixed", Font.PLAIN, 14);

        b1_l = new Button( "Load Demo IDL 1" );
        b2_l = new Button( "Load Demo IDL 2" );
        b3_l = new Button( "Load Demo IDL 3" );
        t1_l = new TextArea( 12, 40 );
        t1_l.setFont (fixed14);
        b_clear1_l = new Button( "Clear content" );
        b_to_cg_l = new Button( "Convert IDL -> CG" );
        b_from_cg_l = new Button( "Convert CG -> IDL" );
        c_l = new Choice();
        c_l.addItem( "CORBA-IDL" );
        c_l.addItem( "DCE-IDL" );
        t2_l = new TextArea( 12, 40 );
        t2_l.setFont (fixed14);
        b_clear2_l = new Button( "Clear content" );

        b1_r = new Button( "Load Demo IDL 1" );
        b2_r = new Button( "Load Demo IDL 2" );
        b3_r = new Button( "Load Demo IDL 3" );
        t1_r = new TextArea( 12, 40 );
        t1_r.setFont (fixed14);
        b_clear1_r = new Button( "Clear content" );
        b_to_cg_r = new Button( "Convert IDL -> CG" );
        b_from_cg_r = new Button( "Convert CG -> IDL" );
        c_r = new Choice();
        c_r.addItem( "CORBA-IDL" );
        c_r.addItem( "DCE-IDL" );
        t2_r = new TextArea( 12, 40 );
        t2_r.setFont (fixed14);
        b_clear2_r = new Button( "Clear content" );
        
        l_1 = new Label( "-" );
        l_2 = new Label( "-" );
        l_3 = new Label( "-" );
        b_comp = new Button( "Compute Subtypes" );
        
        p_l = new Panel();
        p_l.setLayout( gridbag );
        constrain( p_l, b1_l, 0, 0, 1, 1 );
        constrain( p_l, b2_l, 1, 0, 1, 1 );
        constrain( p_l, b3_l, 2, 0, 1, 1 );
        constrain( p_l, new Label( "IDL 1:" ), 0, 1, 3, 1, 15, 0, 0, 0 );
        constrain( p_l, t1_l, 0, 2, 3, 1,
                   GridBagConstraints.BOTH, GridBagConstraints.CENTER,
                   1.0, 1.0,
                   0, 0, 0, 0);
        constrain( p_l, b_clear1_l, 0, 3, 3, 1, GridBagConstraints.HORIZONTAL,
                   GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 10, 0 );
        constrain( p_l, b_to_cg_l, 0, 4, 1, 1, 0, 0, 10, 0 );
        constrain( p_l, b_from_cg_l, 0, 5, 1, 1 );
        constrain( p_l, c_l, 1, 5, 1, 1 );
        constrain( p_l, new Label( "Conceptual Graph 1:" ), 0, 6, 3, 1,
                   15, 0, 0, 0 );
        constrain( p_l, t2_l, 0, 7, 3, 1,
                   GridBagConstraints.BOTH, GridBagConstraints.CENTER,
                   1.0, 1.0,
                   0, 0, 0, 0);
        constrain( p_l, b_clear2_l, 0, 8, 3, 1, GridBagConstraints.HORIZONTAL,
                   GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 10, 0 );
        
        p_r = new Panel();
        p_r.setLayout( gridbag );
        constrain( p_r, b1_r, 0, 0, 1, 1 );
        constrain( p_r, b2_r, 1, 0, 1, 1 );
        constrain( p_r, b3_r, 2, 0, 1, 1 );
        constrain( p_r, new Label( "IDL 2:" ), 0, 1, 3, 1, 15, 0, 0, 0 );
        constrain( p_r, t1_r, 0, 2, 3, 1,
                   GridBagConstraints.BOTH, GridBagConstraints.CENTER,
                   1.0, 1.0,
                   0, 0, 0, 0);
        constrain( p_r, b_clear1_r, 0, 3, 3, 1, GridBagConstraints.HORIZONTAL,
                   GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 10, 0 );
        constrain( p_r, b_to_cg_r, 0, 4, 1, 1, 0, 0, 10, 0 );
        constrain( p_r, b_from_cg_r, 0, 5, 1, 1 );
        constrain( p_r, c_r, 1, 5, 2, 1 );
        constrain( p_r, new Label( "Conceptual Graph 2:" ), 0, 6, 3, 1,
                   15, 0, 0, 0 );
        constrain( p_r, t2_r, 0, 7, 3, 1,
                   GridBagConstraints.BOTH, GridBagConstraints.CENTER,
                   1.0, 1.0,
                   0, 0, 0, 0);
        constrain( p_r, b_clear2_r, 0, 8, 3, 1, GridBagConstraints.HORIZONTAL,
                   GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 10, 0 );
        
        p_b = new Panel();
        p_b.setLayout( gridbag );
        constrain( p_b, new Label( "IDL 1 is a DCE-subtype of IDL 2:" ),
                   0, 0, 1, 1 );
        constrain( p_b, l_1, 1, 0, 1, 1 );
        constrain( p_b, new Label( "IDL 1 is a CORBA-subtype of IDL 2:" ),
                   0, 1, 1, 1 );
        constrain( p_b, l_2, 1, 1, 1, 1 );
        constrain( p_b, new Label( "IDL 1 is a ODP-subtype of IDL 2:" ),
                   0, 2, 1, 1 );
        constrain( p_b, l_3, 1, 2, 1, 1 );
        constrain( p_b, b_comp, 0, 3, 1, 3 );
        
        this.setLayout( gridbag );
        constrain( this, p_l, 0, 0, 1, 1, GridBagConstraints.VERTICAL,
                   GridBagConstraints.NORTHWEST, 0.0, 1.0, 10, 10, 5, 5 );
        constrain( this, p_r, 1, 0, 1, 1, GridBagConstraints.BOTH,
                   GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0 );
        constrain( this, p_b, 0, 1, 2, 1, GridBagConstraints.HORIZONTAL,
                   GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0 );
    }

    void constrain( Container container, Component component,
                    int grid_x, int grid_y, int grid_width, int grid_height,
                    int fill, int anchor, double weight_x, double weight_y,
                    int top, int left, int bottom, int right )
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = grid_x; c.gridy = grid_y;
        c.gridwidth = grid_width; c.gridheight = grid_height;
        c.fill = fill; c.anchor = anchor;
        c.weightx = weight_x; c.weighty = weight_y;
        if( top + bottom + left + right > 0 )
            c.insets = new Insets( top, left, bottom, right );
        ((GridBagLayout) container.getLayout()).setConstraints( component, c );
        container.add( component );
    }

    void constrain( Container container, Component component,
                    int grid_x, int grid_y, int grid_width, int grid_height ) {
        constrain( container, component, grid_x, grid_y, grid_width,
                   grid_height, GridBagConstraints.NONE,
                   GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 0, 0 );
    }

    void constrain( Container container, Component component,
                    int grid_x, int grid_y, int grid_width, int grid_height,
                    int top, int left, int bottom, int right ) {
        constrain( container, component, grid_x, grid_y, grid_width,
                   grid_height, GridBagConstraints.NONE,
                   GridBagConstraints.NORTHWEST,
                   0.0, 0.0, top, left, bottom, right );
    }
 
public void start()
    {
        String aitserverHost;

        aitserverHost = this.getCodeBase().getHost();
	aitserverHost = "apple.ap-c.org";
        if( !toolset.start( aitserverHost ) ) {
            lostConnection();
        }
    }

public void stop()
    {
        toolset.stop();
    }


    void lostConnection()
    {
        removeAll();
        setLayout( new BorderLayout() );
        add( "Center", new Label( "Could not connect to AI-Trader server!",
                                  Label.CENTER ) );
    }


    /** Draws a box around this panel. */
public void paint(Graphics g)
    {
        Dimension d = size();
        g.drawRect(0,0, d.width - 1, d.height - 1);
    }
        
    /** Puts a little breathing space between
      * the panel and its contents, which lets us draw a box
      * in the paint() method.
      */
    public Insets insets()
    {
        return new Insets(5,5,5,5);
    }

public boolean handleEvent( Event e )
    {
        if( (e.target == b1_l) && (e.id == Event.ACTION_EVENT) ) {
            t1_l.setText( DemoIDL.idl1 );
        }
        if( (e.target == b2_l) && (e.id == Event.ACTION_EVENT) ) {
            t1_l.setText( DemoIDL.idl2 );
        }
        if( (e.target == b3_l) && (e.id == Event.ACTION_EVENT) ) {
            t1_l.setText( DemoIDL.idl3 );
        }
        if( (e.target == b1_r) && (e.id == Event.ACTION_EVENT) ) {
            t1_r.setText( DemoIDL.idl1 );
        }
        if( (e.target == b2_r) && (e.id == Event.ACTION_EVENT) ) {
            t1_r.setText( DemoIDL.idl2 );
        }
        if( (e.target == b3_r) && (e.id == Event.ACTION_EVENT) ) {
            t1_r.setText( DemoIDL.idl3 );
        }
        
        if( (e.target == b_clear1_l) && (e.id == Event.ACTION_EVENT) ) {
            t1_l.setText( "" );
        }
        
        if( (e.target == b_clear1_r) && (e.id == Event.ACTION_EVENT) ) {
            t1_r.setText( "" );
        }
        
        if( (e.target == b_clear2_l) && (e.id == Event.ACTION_EVENT) ) {
            t2_l.setText( "" );
        }
        
        if( (e.target == b_clear2_r) && (e.id == Event.ACTION_EVENT) ) {
            t2_r.setText( "" );
        }
        
        if( (e.target == b_to_cg_l) && (e.id == Event.ACTION_EVENT) ) {
            String idl = t1_l.getText();
            if( idl != "" )
                t2_l.setText( toolset.ConvertIDLtoCG( idl ) );
        }
        
        if( (e.target == b_to_cg_r) && (e.id == Event.ACTION_EVENT) ) {
            String idl = t1_r.getText();
            if( idl != "" )
                t2_r.setText( toolset.ConvertIDLtoCG( idl ) );
        }
        
        if( (e.target == b_from_cg_l) && (e.id == Event.ACTION_EVENT) ) {
            String cg = t2_l.getText();
            if( cg != "" )
                t1_l.setText( toolset.ConvertCGtoIDL( cg,
                                                      c_l.getSelectedIndex() ) );
        }
        
        if( (e.target == b_from_cg_r) && (e.id == Event.ACTION_EVENT) ) {
            String cg = t2_r.getText();
            if( cg != "" )
                t1_r.setText( toolset.ConvertCGtoIDL( cg,
                                                      c_r.getSelectedIndex() ) );
        }
        
        if( (e.target == b_comp) && (e.id == Event.ACTION_EVENT) ) {
            String idl1 = t1_l.getText();
            String idl2 = t1_r.getText();
            if( idl1 != "" && idl2 != "" ) {
                String result = toolset.TestSubtypeRules( idl1, idl2 );
                l_1.setText( result.charAt( 0 ) == '0' ? "no" : "yes" );
                l_2.setText( result.charAt( 1 ) == '0' ? "no" : "yes" );
                l_3.setText( result.charAt( 2 ) == '0' ? "no" : "yes" );
            }
        }
        
        return false;
    }

}



class IDLToolSet {
    TransportLayer	transportLayer;

    
public String ConvertIDLtoCG( String idl )
    {
        return ExecRequest( "@idl-tool-conv-to-cg " + idl );
    }

public String ConvertCGtoIDL( String cg, int idl_type )
    {
        String command = "";

        switch( idl_type ) {
        case 0:
            command = "@idl-tool-conv-to-corba " + cg;
            break;
        case 1:
            command = "@idl-tool-conv-to-dce " + cg;
            break;
        }
        return ExecRequest( command );
    }
    
public String TestSubtypeRules( String idl1, String idl2 )
    {
        return ExecRequest( "@idl-tool-test-subtype " + idl1 + '\0' + idl2 );
    }

    String ExecRequest( String command )
    {
        if( transportLayer == null ) {
            return "000";
        }
        return transportLayer.transmitString( command );
    }
    
public boolean start( String aitserverHost )
    {
        transportLayer = new TransportLayer( aitserverHost );
        return transportLayer.connected();
    }
    
public void stop()
    {
        transportLayer.disconnect();
        transportLayer = null;
    }
}
