/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


import java.util.*;
import ConceptualGraph;
import Proxy;


public class Main {
	public static void main (String args[]) {

		/*
		 * First test: construct a little CG and print it.
		 * The graph contructed is
                 * [A]-
		 *	->(B)-
		 *		->[C:{D,E}],
		 *		->[F].,
		 *	->(G)->[H].
		 */
		Node n1, n2, n3, n4, n5, n6;
		Vector inst;

		inst = new Vector();
		n1 = new ConceptNode( "A", inst );
		n2 = new RelationNode( "B" );
		inst = new Vector();
		inst.addElement( "D" );
		inst.addElement( "E" );
		n3 = new ConceptNode( "C", inst );
		n4 = new ConceptNode( "F", new Vector() );
		n5 = new RelationNode( "G" );
		n6 = new ConceptNode( "H", new Vector() );
		
		ConceptualGraph cg1, cg2, cg3, cg4, cg5, cg6;
		cg6 = new ConceptualGraph( n6, null, null );
		cg4 = new ConceptualGraph( n4, null, null );
		cg5 = new ConceptualGraph( n5, cg6, null );
		cg3 = new ConceptualGraph( n3, null, cg4 );
		cg2 = new ConceptualGraph( n2, cg3, cg5 );
		cg1 = new ConceptualGraph( n1, cg2, null );
		StringBuffer ostr;
		ostr = new StringBuffer();
		cg1.print( ostr, 2 );
		System.out.println( ostr.toString() );


		/*
		 * Second test: set-up a connection to a remote aitserver
		 * via the Proxy-class.
		 */


		Proxy remoteServer = new Proxy( new TransportLayer( "localhost" ) );
		String version=new String();
		String key;
		try {
			version = remoteServer.getVersion();
		//	key = remoteServer.add( cg1 );
		} catch( AITException e ) {
			System.out.println( "AI-Trader error: " +
								e.getErrMsg() );
		}

        System.out.println(version);

	}
}

