/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

import java.lang.*;
import java.util.*;

public class MatchResult {
private String  key;
private Integer matchval;
    
public MatchResult (String key, Integer matchval)
    {
        this.key = key;
        this.matchval = matchval;
    }

public String GetKey ()
    {
        return key;
    }

public int GetMatchVal ()
    {
        return matchval.intValue();
    }

public static Vector ExtractKeys (Vector mres)
    {
        Vector v = new Vector();

        for (int i = 0; i < mres.size(); ++i) {
            v.addElement (((MatchResult)mres.elementAt(i)).key);
        }
        return v;
    }

public static Vector SortByMatchVal (Vector mres)
    {
        int sz = mres.size();
        for (int i = 0; i < sz; ++i) {
            for (int j = sz-2; j >= i; --j) {
                MatchResult m1 = (MatchResult)mres.elementAt(j);
                MatchResult m2 = (MatchResult)mres.elementAt(j+1);
                if (m1.matchval.intValue() < m2.matchval.intValue()) {
                    mres.setElementAt (m2, j);
                    mres.setElementAt (m1, j+1);
                }
            }
        }
        return mres;
    }

public static Vector RemoveJunk (Vector mres, Integer minval)
    {
        for (int i = 0; i < mres.size(); ) {
            MatchResult m = (MatchResult)mres.elementAt(i);
            if (m.matchval.intValue() < minval.intValue())
                mres.removeElementAt (i);
            else
                ++i;
        }
        return mres;
    }
}
