/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

import java.awt.*;
import GlobalVars;

public class Scale extends Panel {
private Scrollbar sb;
private Label lb;
private int from, to, res, curr;
    
public Scale (int from, int to, int res, int curr)
    {
        this.from = from;
        this.to = to;
        this.res = res;
        this.curr = curr;

        setLayout (new GridBagLayout());
        sb = new Scrollbar (Scrollbar.HORIZONTAL);
        lb = new Label (Integer.toString (curr), Label.CENTER);

        GlobalVars.constrain (this, lb, 0, 0, 1, 1,
                              GridBagConstraints.BOTH,
                              1.0, 0.0);
        GlobalVars.constrain (this, sb, 0, 1, 1, 1,
                              GridBagConstraints.BOTH,
                              1.0, 0.0);

        configSb ();
    }

private void configSb ()
    {
        int pagesize = Math.max (1, (from-to)/10);
        sb.setValues (curr, pagesize, from, to);
        sb.setPageIncrement (pagesize);
        sb.setLineIncrement (1);
    }

public boolean handleEvent (Event ev)
    {
        switch (ev.id) {
        case Event.SCROLL_LINE_UP:
        case Event.SCROLL_LINE_DOWN:
        case Event.SCROLL_PAGE_UP:
        case Event.SCROLL_PAGE_DOWN:
        case Event.SCROLL_ABSOLUTE:
            curr = ((Integer)ev.arg).intValue();
            lb.setText (Integer.toString (curr));
            return true;
        }
        return false;
    }

public int getValue ()
    {
        return curr;
    }
}
