/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

import java.lang.*;
import java.util.*;
import java.awt.*;

import GlobalVars;
import Scale;

class ScaleBox extends Dialog {
private Scale scale;
private Button ok, cancel;
private int button;

public ScaleBox (String title, String caption,
                 int from, int to, int res, int curr)
    {
        this (title, caption, from, to, res, curr, GlobalVars.frame);
    }

public ScaleBox (String title, String caption,
                 int from, int to, int res, int curr,
                 Frame parent)
    {
        super (parent, title, true);

        button = 0;

        Panel p1 = new Panel();
        Panel p2 = new Panel();

        add ("North", p1);
        add ("South", p2);

        p1.add ("West", new Label (caption));
        scale = new Scale (from, to, res, curr);
        p1.add ("West", scale);

        ok = new Button ("Ok");
        cancel = new Button ("Cancel");
        p2.add ("West", ok);
        p2.add ("West", cancel);

        Dimension d = getLayout().minimumLayoutSize(this);
        resize (d.width, d.height);
    }

public int GetValue ()
    {
        return scale.getValue ();
    }

public int GetButton ()
    {
        return button;
    }
    
public boolean handleEvent (Event e)
    {
        switch (e.id) {
        case Event.ACTION_EVENT:
            if (e.target == ok || e.target == cancel) {
                button = (e.target == cancel) ? 1 : 0;
                dispose ();
                return true;
            }
            break;
        }
        return false;
    }
}
