
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


import java.awt.*;
import java.applet.Applet;
import TransportLayer;


public class Shell extends Applet {
	TransportLayer	transportLayer;
	TextField		textField;
	TextArea		textAreaOutput;

    public void init() {
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
		setLayout( gridbag );

		c.fill = GridBagConstraints.BOTH;

		c.gridwidth = GridBagConstraints.RELATIVE;
		Label label = new Label( "Command:" );
		gridbag.setConstraints( label, c );
		add( label );

		c.gridwidth = GridBagConstraints.REMAINDER;
		textField = new TextField( "", 20 );
		gridbag.setConstraints( textField, c );
		add( textField );

		label = new Label( "Output:" );
		gridbag.setConstraints( label, c );
		add( label );

		textAreaOutput = new TextArea( "" );
		textAreaOutput.setEditable( false );
		gridbag.setConstraints( textAreaOutput, c );
		add( textAreaOutput );

		Button buttonClear = new Button( "Clear Output" );
		gridbag.setConstraints( buttonClear, c );
		add( buttonClear );
    }


	public void start() {
		String aitserverHost;

                aitserverHost = this.getCodeBase().getHost();
		aitserverHost = "apple.ap-c.org";
		transportLayer = new TransportLayer( aitserverHost );
		if( !transportLayer.connected() ) {
			lostConnection();
		}
	}

	public void stop() {
            transportLayer.disconnect ();
            transportLayer = null;
	}


	void lostConnection() {
		removeAll();
		setLayout( new BorderLayout() );
		add( "Center", new Label( "Could not connect to AI-Trader server!", Label.CENTER ) );
	}


    /** Draws a box around this panel. */
    public void paint(Graphics g) {
        Dimension d = size();
        g.drawRect(0,0, d.width - 1, d.height - 1);
    }
        
    /** Puts a little breathing space between
      * the panel and its contents, which lets us draw a box
      * in the paint() method.
      */
    public Insets insets() {
        return new Insets(5,5,5,5);
    }

	public boolean handleEvent( Event e ) {
		if( (e.target instanceof TextField) &&
			(e.id == Event.ACTION_EVENT) ) {
			String in = textField.getText();
			textField.selectAll();
			String out = transportLayer.transmitString( in );
			textAreaOutput.appendText( out );
			textAreaOutput.appendText( "\n" );
		}
		if( e.target instanceof Button ) {
			textAreaOutput.setText( "" );
		}
		return false;
	}

}


