
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

// $Id: access.cc,v 1.6 1997/06/27 16:18:07 roemer Exp $

#include <stream.h>
#include <strstream.h>
#include "access.h"


AccessChecker::AccessChecker()
{
    allowed = true;
}


AccessChecker::~AccessChecker()
{
}


ErrorString AccessChecker::GetVersion( string &version )
{
    return ErrorString();
}


ErrorString AccessChecker::SetVerbose( bool flag )
{
    allowed = false;
    return ErrorString();
}


ErrorString AccessChecker::SaveTraderDB( string *name )
{
    allowed = false;
    return ErrorString();
}
    
    
ErrorString AccessChecker::DefineMatchingRule( string *name, string *rule )
{
    allowed = false;
    return ErrorString();
}


ErrorString AccessChecker::DeleteMatchingRule( string *name )
{
    allowed = false;
    return ErrorString();
}


ErrorString AccessChecker::GetMatchingRuleNames( string *names )
{
    return ErrorString();
}



ErrorString AccessChecker::GetMatchingRule( string *name, string *rule )
{
    return ErrorString();
}



ErrorString AccessChecker::DictQuickMode( bool flag )
{
    return ErrorString();
}


ErrorString AccessChecker::RegisterRelation( string &rel, int prop )
{
    return ErrorString();
}

ErrorString AccessChecker::GetRelationProperties (string &rel, int &prop)
{
    return ErrorString();
}

ErrorString AccessChecker::GetAllRelations( SetOfString &rels )
{
    return ErrorString();
}


ErrorString AccessChecker::DeleteWord( string &word )
{
    return ErrorString();
}


ErrorString AccessChecker::AddWord( string &word )
{
    return ErrorString();
}


ErrorString AccessChecker::ContainsWord( string &word, bool &yesno )
{
    return ErrorString();
}



ErrorString AccessChecker::AddRelation( string &word1, string &rel, string &word2 )
{
    return ErrorString();
}



ErrorString AccessChecker::GetRelationPred( string &word, string &rel,
                                            SetOfWord &pred )
{
    return ErrorString();
}

ErrorString AccessChecker::GetRelationAllPred( string &word, string &rel,
                                               SetOfWord &pred )
{
    if (!((string &)rel == string ("SYNONYM")))
        allowed = false;
    return ErrorString();
}


ErrorString AccessChecker::GetRelationSucc( string &word, string &rel,
                                            SetOfWord &succ )
{
    return ErrorString();
}

ErrorString AccessChecker::GetRelationAllSucc( string &word, string &rel,
                                               SetOfWord &succ )
{
    if (!((string &)rel == string ("SYNONYM")))
        allowed = false;
    return ErrorString();
}


ErrorString AccessChecker::AreRelated( string &word1, SetOfString &rels, string &word2,
                                       bool &yesno )
{
    return ErrorString();
}


ErrorString AccessChecker::Add( ConceptualGraph *cg, KeyCG &newKey )
{
    return ErrorString();
}


ErrorString AccessChecker::Replace( KeyCG aKey, ConceptualGraph *cg )
{
    return ErrorString();
}


ErrorString AccessChecker::Join( KeyCG aKey, ConceptualGraph *cg )
{
    return ErrorString();
}


ErrorString AccessChecker::Match( ConceptualGraph *cg,
                                  SetOfString &selecRules,
                                  SetOfMatchResult &matches,
                                  KeyCG profile)
{
    return ErrorString();
}


ErrorString AccessChecker::GetGraph( KeyCG aKey, ConceptualGraph **cg )
{
    return ErrorString();
}


ErrorString AccessChecker::GetNumberOfVariants( string &conType, int &num )
{
    return ErrorString();
}


ErrorString AccessChecker::GetNthVariant( string &conType, int num, KeyCG &theKey )
{
    return ErrorString();
}


ErrorString AccessChecker::GetNumberOfGraphs( int &num )
{
    return ErrorString();
}


ErrorString AccessChecker::GetNthGraph( int num, KeyCG &theKey )
{
    return ErrorString();
}


ErrorString AccessChecker::AddProvider( KeyCG aKey,
				string &theMaintainer, string &anOID )
{
    return ErrorString();
}


ErrorString AccessChecker::RemoveProvider( KeyCG aKey, string &anOID )
{
    return ErrorString();
}


ErrorString AccessChecker::GetProviders( KeyCG aKey, SetOfServiceEntry &result )
{
    return ErrorString();
}


ErrorString AccessChecker::CreateProfile( KeyCG &aKey )
{
    return ErrorString();
}

ErrorString AccessChecker::RemoveProfile( KeyCG aKey )
{
    return ErrorString();
}

ErrorString AccessChecker::SetMinmatchval( KeyCG aKey, long minmatchval )
{
    return ErrorString();
}

ErrorString AccessChecker::SetTimeout( KeyCG aKey, long timeout )
{
    return ErrorString();
}

ErrorString AccessChecker::GetMinmatchval( KeyCG aKey, long &minmatchval )
{
    return ErrorString();
}

ErrorString AccessChecker::GetTimeout( KeyCG aKey, long &timeout )
{
    return ErrorString();
}


void AccessChecker::SetError( int err, string *msg )
{
}

bool AccessChecker::CheckForError()
{
    return false;
}


void AccessChecker::SetAnswer()
{
}


void AccessChecker::SetAnswer( ConceptualGraph *cg )
{
}


void AccessChecker::SetAnswer( bool flag )
{
}


void AccessChecker::SetAnswer( string &str )
{
}


void AccessChecker::SetAnswer( SetOfMatchResult &result )
{
}


void AccessChecker::SetAnswer( SetOfServiceEntry &entries )
{
}



void AccessChecker::SetAnswer( SetOfWord &word_set )
{
}


void AccessChecker::SetAnswer( KeyCG aKey )
{
}


void AccessChecker::SetAnswer( long number )
{
}


ErrorString AccessChecker::GetAnswer()
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( ConceptualGraph **cg )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( bool &flag )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( string &str )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( SetOfMatchResult &result )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( SetOfServiceEntry &entries )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( SetOfWord &word_set )
{
    return ErrorString();
}


ErrorString AccessChecker::GetAnswer( KeyCG &aKey )
{
    return ErrorString();
}

ErrorString AccessChecker::GetAnswer( long &number )
{
    return ErrorString();
}

string AccessChecker::GetAnswerString()
{
    return string();
}
