
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


/* CHB
	Name:	  rpc_client.h
	Created:  15.10.1995, Wolfgang Schmitz
	Modified: 07.11.1995, Arno Puder
			  18.11.1995, Wolfgang Schmitz
			  	New functions added
			  20.11.1995, Wolfgang Schmitz
			  	New function ForceShutdown added
	------------------------------------------------------------
	The client class header file ...
CHE */



#ifndef __RPC_CLIENT_H__
#define __RPC_CLIENT_H__



class RPCClient {
	public:
		RPCClient( char *HostName, u_long ProgNr, int Timeout );
		~RPCClient( void );

		int Connect( char *User, int *rc );
		int Disconnect( char *User, int *rc );
		int ExecRequest( char *InString, char **Result );
		int InitShutdown( char *PassWord, int *rc );
		int ForceShutdown( char *PassWord, int *rc );
		int GetErrorCode( void );
	
	private:
		int		rc;
		CLIENT	*ClientHandle;
};



#endif
