
/* CHB
	Name:	  trader_rpc.x
	Created:  20.09.1995
	Modified: Wolfgang Schmitz
	------------------------------------------------------------
	Specification of the RPC interface to the AI trader. The
	RPC interfaces supplies to functions:
	    -- Execution of a request
		-- System termination

	The variable trader_prog_nr is defined as external in the gene-
	rated server code. Before running the server's main loop this
	variable has to be declared globally and set to an appropriate
	RPC program number.

	The server's main loop is called by server_main();
CHE */


/* Add the following code to the generated server code */
#ifdef RPC_SVC

%/* run the server in the foreground */
%#define RPC_SVC_FG
 
%#define main	server_main
%extern u_long	trader_prog_nr;

#endif


/* Add the following code to the generated header file */
#ifdef RPC_HDR

%int server_main();

#endif


program TRADER_PROG {
	version TRADER_VERS {
		int connect( string ) = 1;
		int disconnect( string ) = 2;
		string exec_request( string ) = 3;
		int init_shutdown( string ) = 4;
		int force_shutdown( string ) = 5;
	} = 1;
} = trader_prog_nr;
