
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */



/* CHB
	Name:	  server.h
	Created:  05.10.1995, Wolfgang Schmitz
	Modified: 07.11.1995, Arno Puder
			  18.11.1995, Wolfgang Schmitz
			  	Declaration of ResultString removed
				Declaration of functions Connect, Disconnect and
					Shutdown added
			  20.11.1995 New function InitShutdown, Shutdown re-
			  	named to Force Shutdown
	------------------------------------------------------------
	The server class' header file ...
CHE */



#ifndef __RPC_SERVER_H__
#define __RPC_SERVER_H__

#include <sys/types.h>
#include <rpc/rpc.h>


extern "C" int server_main( int, char** );
extern "C" char **exec_request_1( char**, CLIENT* );



class RPCServer {
	public:
		RPCServer( u_long ProgNr );
		virtual ~RPCServer( void );
		void RunServer( void );
		int GetErrorCode( void );
	
		virtual int Connect( char *User ) = NULL;
		virtual int Disconnect( char *User ) = NULL;
		virtual void ExecRequest( char *Request, char **Result ) = NULL;
		virtual int InitShutdown( char *Passwd ) = NULL;
		virtual int ForceShutdown( char *Passwd ) = NULL;
	
	private:
		int		rc;
};



#endif
