
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


// $Id: proxy.h,v 1.3 1996/04/30 15:10:42 roemer Exp $


#ifndef __TCL_PROXY_H__
#define __TCL_PROXY_H__

#include <string.h>
#include <Trader.h>

#define SPECIALIZATION   string( "SPECIALIZATION" )
#define SYNONYM          string( "SYNONYM" )
#define ANTONYM          string( "ANTONYM" )
#define SOMETHING        string( "SOMETHING" )
#define NOTHING          string( "NOTHING" )


class LocalTclClient : public Server 
{
public:
	LocalTclClient();
	ErrorString Connect( string initialKB );
	ErrorString Disconnect();
	void ConvertToTcl( ostream &ostr, ConceptualGraph *cg );
};

#endif
