#include <iostream.h>
#include "dict.h"


inline void test(bool b)
{
    cout << (b?"test ok":"test failed") << endl;
}


const char ait_syn[]="SYNONYM";
const char ait_ant[]="ANTONYM";
const char ait_isa[]="IS_A";
const char ait_hasa[]="HAS_A";


main()
{
    cout << "test dictionary" << endl;
    Dict d;
    d.RegisterRelation(ait_syn, Dict::RelSymmetric|Dict::RelReflexive|Dict::RelTransitive);
    d.RegisterRelation(ait_ant, Dict::RelSymmetric);
    d.RegisterRelation(ait_isa, Dict::RelTransitive|Dict::RelAcyclic|Dict::RelReflexive);
    d.RegisterRelation(ait_hasa, Dict::RelTransitive|Dict::RelAcyclic|Dict::RelReflexive);

    // test basic operations
    d.AddWord("hallo");
    test(d.ContainsWord("hallo"));
    test(!d.ContainsWord("hhallo"));
    test(d.ContainsWord("Hallo"));
    d.AddWord("begruessung");
    test(d.AddRelation("hallo", ait_isa, "begruessung"));

    // test automatic removal of unnecessary relations
    d.AddWord("output device");
    d.AddWord("standard device");
    d.AddWord("printer");
    d.AddWord("laser printer");
    d.AddWord("hp4");
    d.AddWord("hp4msix");
    d.AddRelation("hp4", ait_isa, "output device");
    d.AddRelation("laser printer", ait_isa, "printer");
    d.AddRelation("printer", ait_isa, "output device");
    d.AddRelation("laser printer", ait_isa, "standard device");
    d.AddRelation("hp4msix", ait_isa, "hp4");
    d.AddRelation("hp4msix", ait_isa, "standard device");
    cout << "should now remove \"hp4\"->\"output_device\"" << endl;
    cout << "should now remove \"hp4msix\"->\"standard_device\"" << endl;
    d.AddRelation("hp4", ait_isa, "laser printer");
    //
    d.AddWord("another printer");
    d.AddWord("another laser printer");
    d.AddWord("another hp4");
    d.AddRelation("another hp4", ait_isa, "another printer");
    d.AddRelation("another hp4", ait_isa, "another laser printer");
    cout << "should now remove \"another_hp4\"->\"another_printer\"" << endl;
    d.AddRelation("another laser printer", ait_isa, "another printer");
    
    // test AreRelated
    d.AddWord("action");
    d.AddWord("use");
    d.AddWord("utilization");
    d.AddWord("abutilization");
    d.AddRelation("use", ait_syn, "utilization");
    d.AddRelation("use", ait_isa, "action");
    d.AddRelation("abutilization", ait_isa, "utilization");
    vector<string> rels;
    rels.push_back(ait_isa);
    rels.push_back(ait_syn);
    test(d.AreRelated("abutilization", rels, "action"));
    //
    d.AddWord("non-use");
    d.AddRelation("use", ait_ant, "non-use");
    vector<string> rels2;
    rels2.push_back(ait_ant);
    rels2.push_back(ait_syn);
    test(!d.AreRelated("use", rels2, "utilization"));
    test(d.AreRelated("non-use", rels2, "utilization"));

    // test output
    cout << d;
}


