
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


// $Id: error.cc,v 1.4 1997/06/27 16:19:13 roemer Exp $


#include <stdio.h>
#include <stdarg.h>
#include "error.h"


ErrorString LastErrorString( 0 );


static char *ErrorMsg[] = {
	/*   0 */ "No Error",
	/*   1 */ "Attribute >>%s<< already exists",
	/*   2 */ "Relation >>%s<< already exists",
	/*   3 */ "Word >>%s'<< doesn't exist",
	/*   4 */ "Word >>%s<< already exists",
	/*   5 */ "Word >>%s<< or attribute >>%s<< doesn't exist",
	/*   6 */ "Words >>%s<< or >>%s<< or relation >>%s<< doesnt exist",
	/*   7 */ "%s in file >>%s<< in line %d",
	/*   8 */ "%s in line %d",
	/*   9 */ "not implemented",
	/*     */ ""
};



ErrorString::ErrorString( int err, ... )
{
    char    buf[ 200 ];
    va_list p;
    
    va_start( p, err );
	errNum = err;
    vsprintf( buf, ErrorMsg[ err ], p );
    *(string *)this = buf;

	LastErrorString = *this;
    va_end( p );
}


ErrorString::ErrorString( string &msg, int err )
{
	errNum = err;
    *(string *)this = msg;
}


ErrorString::ErrorString()
{
	errNum = 0;
	LastErrorString = *this;
}


void ErrorString::ResetError()
{
	errNum = 0;
}


int ErrorString::GetErrNum()
{
	return errNum;
}


int ErrorString::operator==( int err )
{
	return errNum == err;
}



int ErrorString::operator!=( int err )
{
	return errNum != err;
}


int ErrorString::operator!()
{
	return errNum != 0;
}
