
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */

// $Id: eval.cc,v 1.10 1997/10/13 15:48:51 roemer Exp $

#include "eval.h"
#include "prolog.h"


PrologInterp Evaluator::prologInterp;


Evaluator::Evaluator (MatchingRule &theRules, SetOfString &theSelecRules, 
                      Dict &aDict, ConceptualGraph *aTypeGraph,
                      ConceptualGraph *aQuery)
    : rules (theRules), selecRules (theSelecRules), dict (aDict)
{
    queryGraph = aQuery;
    typeGraph = aTypeGraph;
}

Evaluator::~Evaluator()
{
}

int
Evaluator::StartMatch (bool verb)
{
    int result = 0;
    prologInterp.Match (rules, selecRules, dict, typeGraph, queryGraph,
                         verb, &result);
    return result;
}
