
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


// $Id: eval.h,v 1.7 1997/10/13 15:48:52 roemer Exp $


#ifndef __EVAL_H__
#define __EVAL_H__

#include "dict.h"
#include "match.h"
#include "kb.h"
#include "cg.h"
#include "prolog.h"

class Evaluator {
protected:
	bool			verbose;
	Dict			&dict;
	MatchingRule	&rules;
	SetOfString		&selecRules;
	ConceptualGraph	*typeGraph;
	ConceptualGraph	*queryGraph;
	static PrologInterp prologInterp;
	
public:
	Evaluator (MatchingRule &theRules, SetOfString &theSelecRules,
			   Dict &aDict,
			   ConceptualGraph *aTypeGraph, ConceptualGraph *aQuery);
	~Evaluator ();
	
	int StartMatch (bool verbose_flag);
};

#endif
