
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */



#include <fstream.h>
#include <assert.h>

#include "dict.h"
#include "kb.h"
#include "match.h"


const string NullString;


MatchingRule::MatchingRule()
{
    modified = false;
}


MatchingRule::~MatchingRule()
{
#if 0
    for( Pix i = metarules.first(); i != 0; metarules.next( i ) )
	if( metarules[ metarules.key( i ) ] )
	    delete metarules[ metarules.key( i ) ];
#endif
}


void
MatchingRule::DefineMatchingRule( string &name, string &pn )
{
    if (matchingrules.count (name))
        DeleteMatchingRule (name);
    matchingrules[name] = pn;
    modified = true;
}


string &
MatchingRule::GetMatchingRule( string &name )
{
    return matchingrules[name];
}


void
MatchingRule::DeleteMatchingRule( string &name )
{
    if (matchingrules.count (name)) {
        matchingrules.erase (name);
    }
}

void
MatchingRule::Print( ostream &ostr )
{
    for (iterator i = begin(); i != end(); ++i) {
        if (!((*i).first == "")) { //NullString ) {
            ostr << "@define-matching-rule ";
            ostr << '"' << (*i).first << '"';
            ostr << endl;
            ostr << (*i).second;
            ostr << endl << "@end"<< endl << endl;
        }
    }
}



bool MatchingRule::IsModified ()
{
	bool r = modified;
	modified = false;
	return r;
}
