
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */



#ifndef __MATCH_H__
#define __MATCH_H__

#include "stl.h"


class MatchingRule 
{
public:
    typedef map<string, string, less<string> > MapStringString;
    typedef MapStringString::iterator iterator;
    typedef MapStringString::const_iterator const_iterator;
    
private:
    MapStringString matchingrules;
    bool modified;
    
public:
    MatchingRule();
    ~MatchingRule();
    void DefineMatchingRule( string &name, string &pn );
    string &GetMatchingRule( string &name );
    void DeleteMatchingRule( string &name );
    void Print( ostream &ostr );

    iterator begin () { return matchingrules.begin(); }
    iterator end ()   { return matchingrules.end(); }    

    bool IsModified ();
};


#endif
