
#ifndef __PROLOG_H__
#define __PROLOG_H__

extern "C" {
#include <SWI-Prolog.h>
}
#include "stl.h"
#include "dict.h"
#include "match.h"
#include "kb.h"
#include "cg.h"

class MatchInfo {
    Dict &dict;
    SetOfString	&selectRules;
    bool verbose;

public:
    MatchInfo (Dict &theDict, SetOfString &theSelectRules, bool verb)
            : dict (theDict), selectRules (theSelectRules), verbose (verb)
    {}

    bool IsVerbose () { return verbose; }
    Dict &GetDict () { return dict; }
    SetOfString &GetRules () { return selectRules; }
};


class PrologInterp {
    static int  inited;
    SetOfString files;
    int old_stdout, old_stderr, new_stdout;

    bool UpdateRule (const string &key, const string &value);
    void Silent ();
    void Verbose ();

public:
    PrologInterp ();
    ~PrologInterp ();
    bool Match (MatchingRule &theRules, SetOfString &theSelectRules,
                Dict &theDict,
                ConceptualGraph *type, ConceptualGraph *query, bool verbose,
                int *matchresult = NULL);
};

#endif
