#ifndef __UTIL_H__
#define __UTIL_H__

#include "stl.h"


extern string LocateInitialKB (void);
extern string &gsub (string &s, const string &pat, const string &subst);
extern int fcompare (const string &s1, const string &s2);
extern int contains (const string &s, const string &pat);
extern int split (const string &s, string res[], int maxn, const string &sep);
extern string before (const string &s, const string &pat, int pos = 0);
extern string after (const string &s, const string &pat, int pos = 0);
extern void del (string &s, const string &pat, int pos = 0);
extern void prepend (string &s, const string &s2);
extern int freq (const string &s, const string &pat);
extern void cat (const string &s1, const string &s2, string &res);

template<class T>
static inline set<T, less<T> >&
operator+= (set<T, less<T> >& s1, const set<T, less<T> >& s2)
{
    set<T, less<T> >::const_iterator i;
    for (i = s2.begin(); i != s2.end(); ++i) {
        s1.insert (*i);
    }
    return s1;
}

template<class T>
static inline set<T, less<T> >&
operator-= (set<T, less<T> >& s1, const set<T, less<T> >& s2)
{
    set<T, less<T> >::const_iterator i;
    for (i = s2.begin(); i != s2.end(); ++i) {
        s1.erase (*i);
    }
    return s1;
}

template<class T>
static inline set<T, less<T> >
vector2set (const vector<T>& v)
{
    set<T, less<T> > s;
    vector<T>::const_iterator i;
    for (i = v.begin(); i != v.end(); ++i)
        s.insert (*i);
    return s;
}

template<class T>
static inline vector<T>
set2vector (const set<T, less<T> >& s)
{
    vector<T> v;
    set<T, less<T> >::const_iterator i;
    for (i = s.begin(); i != s.end(); ++i)
        v.insert (v.end(), *i);
    return v;
}


#endif
