
/*
 *  AI-Trader --- Service Trading using Conceptual Graphs
 *  Copyright (C) 1995 Arno Puder et al.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 aitrader@informatik.uni-frankfurt.de
 */


// $Id: word.cc,v 1.8 1998/02/06 11:05:52 roemer Exp $


#include "word.h"
#include "stl.h"
#include <ctype.h>
#include "util.h"

string Word::convert(const char *w)
{
    string s(w);
    for (int i = 0; i < s.size(); ++i) {
        s[i] = isspace(s[i]) ? '_' : tolower(s[i]);
    }
    return s;
}


ostream &operator<<( ostream &o, const Word &w )
{
    string s (w);
    gsub (s, "'", "\\'");
    o << "'" << s.c_str() << "'";
    return o;
}

// eof word.cc
